using System;
using System.Numerics;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Input;

using Windows.System;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainPage()

        /// <summary>
        /// 
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            this.rectangle.ScaleTransition = new Vector3Transition();

            this.scaleButton1.Click     += scaleButton_Click;
            this.scaleButton2.Click     += scaleButton_Click;
            this.scaleButton3.Click     += scaleButton_Click;
            this.scaleNumberBox.KeyDown += scaleNumberBox_KeyDown;
            this.scaleButton.Click      += scaleButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region Scale ѹ ڽ Ű ٿ óϱ - scaleNumberBox_KeyDown(sender, e)

        /// <summary>
        /// Scale ѹ ڽ Ű ٿ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void scaleNumberBox_KeyDown(object sender, KeyRoutedEventArgs e)
        {
            if(e.Key == VirtualKey.Enter)
            {
                scaleButton_Click(null, null);
            }
        }

        #endregion
        #region Scale ư Ŭ óϱ - scaleButton_Click(sender, e)

        /// <summary>
        /// Scale ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void scaleButton_Click(object sender, RoutedEventArgs e)
        {
            Vector3Transition scaleTransition = this.rectangle.ScaleTransition;

            scaleTransition.Components = ((this.scaleXCheckBox.IsChecked == true) ? Vector3TransitionComponents.X : 0) |
                                         ((this.scaleYCheckBox.IsChecked == true) ? Vector3TransitionComponents.Y : 0) |
                                         ((this.scaleZCheckBox.IsChecked == true) ? Vector3TransitionComponents.Z : 0);

            float customValue;

            if(sender != null && (sender as Button).Tag != null)
            {
                customValue = (float)Convert.ToDouble((sender as Button).Tag);
            }
            else
            {
                customValue = NormalizeValue(this.scaleNumberBox);
            }

            this.rectangle.Scale = new Vector3(customValue);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region  ȭϱ - NormalizeValue(numberBox)

        /// <summary>
        ///  ȭϱ
        /// </summary>
        /// <param name="numberBox">ѹ ڽ</param>
        /// <returns></returns>
        private float NormalizeValue(NumberBox numberBox)
        {
            if(double.IsNaN(numberBox.Value))
            {
                numberBox.Value = 0;
            }

            return (float)numberBox.Value;
        }

        #endregion
    }
}